2010-04-15 00:03:46 +04:00
#!/bin/bash
# We use some bash-isms (getopts?)
2015-05-09 02:59:18 +03:00
# Copyright (C) 2007-2015 Red Hat, Inc. All rights reserved.
2010-04-15 00:03:46 +04:00
#
# This file is part of LVM2.
#
# This copyrighted material is made available to anyone wishing to use,
# modify, copy, or redistribute it subject to the terms and conditions
# of the GNU General Public License v.2.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
2016-01-21 13:49:46 +03:00
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
2010-04-15 00:03:46 +04:00
# lvm_dump: This script is used to collect pertinent information for
# the debugging of lvm issues.
# following external commands are used throughout the script
# echo and test are internal in bash at least
MKDIR = mkdir # need -p
TAR = tar # need czf
RM = rm # need -rf
CP = cp
TAIL = tail # we need -n
LS = ls # need -la
PS = ps # need alx
SED = sed
DD = dd
CUT = cut
DATE = date
BASENAME = basename
2012-04-18 19:26:02 +04:00
UDEVADM = udevadm
2010-04-15 00:03:46 +04:00
UNAME = uname
2012-10-12 00:39:40 +04:00
TR = tr
2012-10-12 00:42:20 +04:00
SOCAT = socat # either socat or nc is needed for dumping lvmetad state
NC = nc
2010-04-15 00:03:46 +04:00
# user may override lvm and dmsetup location by setting LVM_BINARY
# and DMSETUP_BINARY respectively
LVM = ${ LVM_BINARY -lvm }
DMSETUP = ${ DMSETUP_BINARY -dmsetup }
2012-10-12 00:42:20 +04:00
LVMETAD_SOCKET = ${ LVM_LVMETAD_SOCKET -/var/run/lvm/lvmetad.socket }
2015-05-09 02:59:18 +03:00
LVMPOLLD_SOCKET = ${ LVM_LVMPOLLD_SOCKET -/var/run/lvm/lvmpolld.socket }
2010-04-15 00:03:46 +04:00
die( ) {
code = $1 ; shift
echo " $@ " 1>& 2
exit $code
}
" $LVM " version >& /dev/null || die 2 " Could not run lvm binary ' $LVM ' "
" $DMSETUP " version >& /dev/null || DMSETUP = :
function usage {
echo " $0 [options] "
echo " -h print this message"
echo " -a advanced collection - warning: if lvm is already hung,"
echo " then this script may hang as well if -a is used"
echo " -c if running clvmd, gather cluster data as well"
2014-04-15 17:27:30 +04:00
echo " -d <directory> dump into a directory instead of tarball"
2012-10-12 00:42:20 +04:00
echo " -l gather lvmetad state if running"
2015-05-09 02:59:18 +03:00
echo " -p gather lvmpolld state if running"
2014-04-15 17:27:30 +04:00
echo " -m gather LVM metadata from the PVs"
echo " -s gather system info and context"
echo " -u gather udev info and context"
2010-04-15 00:03:46 +04:00
echo ""
2011-06-02 13:02:03 +04:00
2010-04-15 00:03:46 +04:00
exit 1
}
advanced = 0
clustered = 0
metadata = 0
2014-04-15 17:27:30 +04:00
sysreport = 0
2012-04-18 19:26:02 +04:00
udev = 0
2015-05-09 02:59:18 +03:00
while getopts :acd:hlpmus opt; do
2010-04-15 00:03:46 +04:00
case $opt in
a) advanced = 1 ; ;
c) clustered = 1 ; ;
d) userdir = $OPTARG ; ;
h) usage ; ;
2014-04-15 17:27:30 +04:00
l) lvmetad = 1 ; ;
2015-05-09 02:59:18 +03:00
p) lvmpolld = 1 ; ;
2010-04-15 00:03:46 +04:00
m) metadata = 1 ; ;
2014-04-15 17:27:30 +04:00
s) sysreport = 1 ; ;
2012-04-18 19:26:02 +04:00
u) udev = 1 ; ;
2010-04-15 00:03:46 +04:00
:) echo " $0 : $OPTARG requires a value: " ; usage ; ;
\? ) echo " $0 : unknown option $OPTARG " ; usage ; ;
*) usage ; ;
esac
done
2012-10-12 00:39:40 +04:00
NOW = ` $DATE -u +%G%m%d%k%M%S | $TR -d ' ' `
2010-04-15 00:03:46 +04:00
if test -n " $userdir " ; then
dir = " $userdir "
else
dirbase = " lvmdump- $HOSTNAME - $NOW "
dir = " $HOME / $dirbase "
fi
2016-04-07 00:36:42 +03:00
if test -d $dir ; then
2016-04-07 00:56:45 +03:00
( shopt -s nullglob dotglob; test -r $dir -a -w $dir -a -x $dir && cd $dir && files = ( *) && ( ( ! ${# files [@] } ) ) ) || \
die 5 " Fatal: directory $dir already exists and is not empty or inaccessible "
2016-04-07 00:36:42 +03:00
else
test -e $dir && die 3 " Fatal: $dir already exists "
$MKDIR -p $dir || die 4 " Fatal: could not create $dir "
fi
2010-04-15 00:03:46 +04:00
log = " $dir /lvmdump.log "
myecho( ) {
echo " $@ "
echo " $@ " >> " $log "
}
log( ) {
echo " $@ " >> " $log "
eval " $@ "
}
warnings( ) {
if test " $UID " != "0" && test " $EUID " != "0" ; then
myecho "WARNING! Running as non-privileged user, dump is likely incomplete!"
elif test " $DMSETUP " = ":" ; then
myecho "WARNING! Could not run dmsetup, dump is likely incomplete."
fi
}
warnings
myecho " Creating dump directory: $dir "
echo " "
if ( ( $advanced ) ) ; then
myecho "Gathering LVM volume info..."
myecho " vgscan..."
2011-06-02 13:02:03 +04:00
log " \" $LVM \" vgscan -vvvv >> \" $dir /vgscan\" 2>&1 "
2010-04-15 00:03:46 +04:00
myecho " pvscan..."
log " \" $LVM \" pvscan -v >> \" $dir /pvscan\" 2>> \" $log \" "
myecho " lvs..."
2016-03-03 12:36:58 +03:00
log " \" $LVM \" lvs -a -H -o +devices >> \" $dir /lvs\" 2>> \" $log \" "
2010-04-15 00:03:46 +04:00
myecho " pvs..."
2011-06-02 13:02:03 +04:00
log " \" $LVM \" pvs -a -v >> \" $dir /pvs\" 2>> \" $log \" "
2010-04-15 00:03:46 +04:00
myecho " vgs..."
2011-06-02 13:02:03 +04:00
log " \" $LVM \" vgs -v >> \" $dir /vgs\" 2>> \" $log \" "
2010-04-15 00:03:46 +04:00
fi
if ( ( $clustered ) ) ; then
myecho "Gathering cluster info..."
{
for i in nodes status services; do
cap_i = $( echo $i | tr a-z A-Z)
printf " $cap_i :\n----------------------------------\n "
log " cman_tool $i 2>> \" $log \" "
echo
done
echo "LOCKS:"
echo "----------------------------------"
if [ -f /proc/cluster/dlm_locks ]
then
2011-06-02 13:08:16 +04:00
echo clvmd > /proc/cluster/dlm_locks
2010-04-15 00:03:46 +04:00
cat /proc/cluster/dlm_locks
echo
echo "RESOURCE DIR:"
cat /proc/cluster/dlm_dir
echo
echo "DEBUG LOG:"
cat /proc/cluster/dlm_debug
echo
fi
if [ -f /debug/dlm/clvmd ]
then
cat /debug/dlm/clvmd
echo
echo "WAITERS:"
cat /debug/dlm/clvmd_waiters
echo
echo "MASTER:"
cat /debug/dlm/clvmd_master
fi
2011-06-02 13:02:03 +04:00
} >> $dir /cluster_info
2010-04-15 00:03:46 +04:00
fi
myecho "Gathering LVM & device-mapper version info..."
2011-06-02 13:02:03 +04:00
echo "LVM VERSION:" >> " $dir /versions "
2010-04-15 00:03:46 +04:00
" $LVM " lvs --version >> " $dir /versions " 2>> " $log "
echo "DEVICE MAPPER VERSION:" >> " $dir /versions "
" $DMSETUP " --version >> " $dir /versions " 2>> " $log "
echo "KERNEL VERSION:" >> " $dir /versions "
" $UNAME " -a >> " $dir /versions " 2>> " $log "
echo "DM TARGETS VERSIONS:" >> " $dir /versions "
" $DMSETUP " targets >> " $dir /versions " 2>> " $log "
myecho "Gathering dmsetup info..."
2011-06-02 13:02:03 +04:00
log " \" $DMSETUP \" info -c >> \" $dir /dmsetup_info\" 2>> \" $log \" "
log " \" $DMSETUP \" table >> \" $dir /dmsetup_table\" 2>> \" $log \" "
log " \" $DMSETUP \" status >> \" $dir /dmsetup_status\" 2>> \" $log \" "
# cat as workaround to avoid tty ioctl (selinux)
log " \" $DMSETUP \" ls --tree 2>> \" $log \" | cat >> \" $dir /dmsetup_ls_tree\" "
2010-04-15 00:03:46 +04:00
myecho "Gathering process info..."
2011-06-02 13:02:03 +04:00
log " $PS alx >> \" $dir /ps_info\" 2>> \" $log \" "
2010-04-15 00:03:46 +04:00
myecho "Gathering console messages..."
2011-06-02 13:02:03 +04:00
log " $TAIL -n 75 /var/log/messages >> \" $dir /messages\" 2>> \" $log \" "
2010-04-15 00:03:46 +04:00
myecho "Gathering /etc/lvm info..."
2013-12-05 19:36:45 +04:00
log " $LS -laR /etc/lvm >> \" $dir /etc_lvm_listing\" 2>> \" $log \" "
log " $CP -RL --preserve=all /etc/lvm \" $dir /lvm\" 2>> \" $log \" "
2014-03-25 16:06:59 +04:00
log " $LVM dumpconfig --type diff --file \" $dir /config_diff\" 2>> \" $log \" "
log " $LVM dumpconfig --type missing --file \" $dir /config_missing\" 2>> \" $log \" "
2010-04-15 00:03:46 +04:00
myecho "Gathering /dev listing..."
2011-06-02 13:02:03 +04:00
log " $LS -laR /dev >> \" $dir /dev_listing\" 2>> \" $log \" "
2010-04-15 00:03:46 +04:00
myecho "Gathering /sys/block listing..."
2011-06-02 13:02:03 +04:00
log " $LS -laR /sys/block >> \" $dir /sysblock_listing\" 2>> \" $log \" "
2010-04-15 00:03:46 +04:00
log " $LS -laR /sys/devices/virtual/block >> \" $dir /sysblock_listing\" 2>> \" $log \" "
if ( ( $metadata ) ) ; then
myecho "Gathering LVM metadata from Physical Volumes..."
log " $MKDIR -p \" $dir /metadata\" "
pvs = " $( " $LVM " pvs --separator , --noheadings --units s --nosuffix -o \
name,pe_start 2>> " $log " | $SED -e 's/^ *//' ) "
for line in $pvs
do
test -z " $line " && continue
pv = " $( echo $line | $CUT -d, -f1) "
pe_start = " $( echo $line | $CUT -d, -f2) "
name = " $( $BASENAME " $pv " ) "
myecho " $pv "
log " $DD if= $pv \"of= $dir /metadata/ $name \" bs=512 count= $pe_start 2>> \" $log \" "
done
fi
2014-04-15 17:27:30 +04:00
if ( ( $sysreport ) ) ; then
myecho "Gathering system info..."
sysreport_dir = " $dir /sysreport "
log_lines = 10000
SYSTEMCTL = $( which systemctl 2>> $log )
JOURNALCTL = $( which journalctl 2>> $log )
2016-06-09 14:51:09 +03:00
LSBLK = $( which lsblk 2>> $log )
log " $MKDIR -p \" $sysreport_dir \" "
if test -z "LSBLK" ; then
myecho "WARNING: lsblk not found"
else
log " $LSBLK -O >> \" $sysreport_dir /lsblk\" "
log " $LSBLK -s >> \" $sysreport_dir /lsblk_s\" "
fi
2014-04-15 17:27:30 +04:00
if test -z " $SYSTEMCTL " ; then
myecho "WARNING: systemctl not found"
elif test -z " $JOURNALCTL " ; then
myecho "WARNING: journalctl not found"
else
log " $JOURNALCTL -b --no-pager -o short-precise > \" $sysreport_dir /journal_content\" 2>> \" $log \" "
log " $SYSTEMCTL status -l --no-pager -n $log_lines -o short-precise dm-event.socket dm-event.service \
lvm2-monitor.service \
lvm2-lvmetad.socket lvm2-lvmetad.service \
2015-05-11 14:31:43 +03:00
lvm2-lvmpolld.socket lvm2-lvmpolld.service \
2014-04-15 17:27:30 +04:00
lvm2-cluster-activation.service \
lvm2-clvmd.service \
lvm2-cmirrord.service \
2016-01-04 17:10:07 +03:00
lvm2-activation-early.service \
lvm2-activation.service \
lvm2-activation-net.service \
2014-04-15 17:27:30 +04:00
> \" $sysreport_dir /systemd_lvm2_services_status\" 2>> \" $log \" "
2014-04-15 17:43:20 +04:00
log " $SYSTEMCTL list-units -l -a --no-legend --no-pager > \" $sysreport_dir /systemd_unit_list\" 2>> \" $log \" "
2014-04-15 17:27:30 +04:00
for unit in $( cat $sysreport_dir /systemd_unit_list | grep lvm2-pvscan | cut -d " " -f 1) ; do
log " $SYSTEMCTL status -l --no-pager -n $log_lines -o short-precise $unit >> \" $sysreport_dir /systemd_lvm2_pvscan_service_status\" "
done
fi
fi
2012-04-18 19:26:02 +04:00
if ( ( $udev ) ) ; then
myecho "Gathering udev info..."
udev_dir = " $dir /udev "
log " $MKDIR -p \" $udev_dir \" "
log " $UDEVADM info --version >> \" $udev_dir /version\" 2>> \" $log \" "
log " $UDEVADM info --export-db >> \" $udev_dir /db\" 2>> \" $log \" "
log " $CP -a /etc/udev/udev.conf \" $udev_dir /conf\" 2>> \" $log \" "
log " $LS -la /lib/udev >> \" $udev_dir /lib_dir\" 2>> \" $log \" "
2013-12-05 19:36:45 +04:00
log " $CP -RL --preserve=all /etc/udev/rules.d \" $udev_dir /rules_etc\" 2>> \" $log \" "
log " $CP -RL --preserve=all /lib/udev/rules.d \" $udev_dir /rules_lib\" 2>> \" $log \" "
2012-04-18 19:26:02 +04:00
fi
2012-10-12 00:42:20 +04:00
if ( ( $lvmetad ) ) ; then
( echo 'request="dump"' ; echo '##' ) | {
if type -p $SOCAT >& /dev/null; then
echo " $SOCAT unix-connect: $LVMETAD_SOCKET - " >> " $log "
$SOCAT " unix-connect: $LVMETAD_SOCKET " - 2>> " $log "
elif echo | $NC -U " $LVMETAD_SOCKET " ; then
echo " $NC -U $LVMETAD_SOCKET " >> " $log "
$NC -U " $LVMETAD_SOCKET " 2>> " $log "
else
myecho "WARNING: Neither socat nor nc -U seems to be available." 1>& 2
echo "# DUMP FAILED"
return 1
fi
} > " $dir /lvmetad.txt "
fi
2015-05-09 02:59:18 +03:00
if ( ( $lvmpolld ) ) ; then
( echo 'request="dump"' ; echo '##' ) | {
if type -p $SOCAT >& /dev/null; then
echo " $SOCAT unix-connect: $LVMPOLLD_SOCKET - " >> " $log "
$SOCAT " unix-connect: $LVMPOLLD_SOCKET " - 2>> " $log "
elif echo | $NC -U " $LVMPOLLD_SOCKET " ; then
echo " $NC -U $LVMPOLLD_SOCKET " >> " $log "
$NC -U " $LVMPOLLD_SOCKET " 2>> " $log "
else
myecho "WARNING: Neither socat nor nc -U seems to be available." 1>& 2
echo "# DUMP FAILED"
return 1
fi
} > " $dir /lvmpolld.txt "
fi
2010-04-15 00:03:46 +04:00
if test -z " $userdir " ; then
lvm_dump = " $dirbase .tgz "
myecho " Creating report tarball in $HOME / $lvm_dump ... "
fi
warnings
if test -z " $userdir " ; then
cd " $HOME "
" $TAR " czf " $lvm_dump " " $dirbase " 2>/dev/null
" $RM " -rf " $dir "
fi
exit 0